# /packages/users-selection/www/admin/selection-execute.tcl
ad_page_contract {
    
    @author Tilmann Singer (tils@tils.net)
    @creation-date Fri Dec 20 21:07:25 2002
} {
    selection_id:integer
    bind_var:array,optional
}


db_1row get_selection {}

set bind_vars_values [db_list_of_lists get_bind_vars {}]

set context_bar [list [list "selection?[export_vars selection_id]" "[_ users-selection.Detail_]"] "[_ users-selection.Execute]"]

if {[empty_string_p $bind_vars]} {
    set show_form_p 0
} else {
    set show_form_p 1

    set ad_form_code "-form \{\n"
    foreach bind_value $bind_vars_values {
	util_unlist $bind_value var_name var_description var_value
	append ad_form_code "\{bind_var.$var_name:text \{label \"$var_description\"\} \{value \"$var_value\"\}\}\n"
    }
    append ad_form_code "\}"
    eval ad_form -name bind_vars_form -action selection-execute -export {selection_id} $ad_form_code
    if {![info exists bind_var]} {
	foreach bind_value $bind_vars_values {
	    util_unlist $bind_value var_name var_description var_value
	    set bind_var($var_name) $var_value
	}
    }
}

set show_result_p 0



if {$show_form_p} {
    if { [array size bind_var] != [llength $bind_vars_values] } {
	ad_return_complaint 1 "[_ users-selection.lt_The_number_of_submitt]"
	ad_script_abort
    }
    # try to execute the query with the user submitted values for
    # the bind vars
    set subs_list [list]
    foreach var_name [array names bind_var] {
	lappend subs_list $var_name $bind_var($var_name)
    }

    set query_string [db_bind_var_substitution $full_sql $subs_list]
} else {
    set query_string $full_sql
}

ns_log notice "!> q: $query_string"

if { [catch {
    # get the count
    set count [db_string count "select count(*) from ($query_string) q"]
    set fields [join [user_selection::get_field_names -query $query_string] ", "]
    set show_result_p 1

    #set resultlist [db_list_of_lists get_resultlist $query_string]
    #if { [llength $resultlist] == 0 } {
    #    set resultlist "(no rows returned)"
    #}
} err] } {
    set query_error "[_ users-selection.lt_The_query_returned_an]"
}

set csv_url "selection-csv?[export_vars [list selection_id bind_var:array]]"

ad_return_template
